#pragma once
#include <glad/glad.h>
#include <vector>
#include <iostream>

class CubeMap
{
private:
    std::vector<const char*> CubemapTextures;
    GLuint TID;
public:
    CubeMap();
    ~CubeMap();

    void Bind();
    void Unbind();

    inline GLuint getCubMapTextureID() const {return TID;}

public:
    GLint loadTextures(std::vector<const char*> cubemapTextures);
};