#pragma once
#include <J3ML/LinearAlgebra/Vector3.h>


using J3ML::LinearAlgebra::Vector2;
using J3ML::LinearAlgebra::Vector3;



namespace LearnOpenGL
{
    constexpr auto MAX_BONE_INFLUENCE = 4;

    /// Define a point with texture coordinates, and more

    struct Vertex
    {
        // TODO: Integrate JGL or split Color into separate module?
        //Color3 Color;
        Vector3 Position;
        Vector3 Normal;
        Vector2 TexCoords;
        Vector3 Tangent;
        Vector3 BiTangent;
        int BoneIDs[MAX_BONE_INFLUENCE];
        float BoneWeights[MAX_BONE_INFLUENCE];
    };
}