#include <LearnOpenGL/FrameBuffer.h>


// TODO: Upgrade to a version of OpenGL that supports FrameBuffer operations???

namespace LearnOpenGL
{
    FrameBuffer::FrameBuffer() {

    }

    FrameBuffer::~FrameBuffer() {

        //glDeleteFramebuffers(1, &BufferID);
    }

    void FrameBuffer::Create(int width, int height, bool enableDepth) {
        //glGenFramebuffers(1, &BufferID);
        //glBindFramebuffer(GL_FRAMEBUFFER, BufferID);

        std::vector<unsigned int> attachments {};
        for (size_t i = 0; i < Attachments.size(); i++)
        {
            //attachments.push_back(GL_COLOR_ATTACHMENT0 + i);
            //glFramebufferTexture2D(GL_FRAMEBUFFER, GL_COLOR_ATTACHMENT0 + i, GL_TEXTURE_2D, Attachments[i], 0);
        }
        glDrawBuffers(attachments.size(), attachments.data());

        if (enableDepth)
        {
            glGenTextures(1, &DepthAttachment);
            glBindBuffer(GL_TEXTURE_2D, DepthAttachment);
            glTexImage2D(GL_TEXTURE_2D, 0, GL_DEPTH_COMPONENT, width, height, 0, GL_DEPTH_COMPONENT, GL_FLOAT, NULL);
            glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
            glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
            glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
            glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
            //glFramebufferTexture2D(GL_FRAMEBUFFER, GL_DEPTH_ATTACHMENT, GL_TEXTURE_2D, DepthAttachment, 0);
        }
        //if (glCheckFramebufferStatus(GL_FRAMEBUFFER) != GL_FRAMEBUFFER_COMPLETE)
        //    std::cout << "ERROR: Framebuffer is not complete" << std::endl;

        //glBindFramebuffer(GL_FRAMEBUFFER, 0);
    }

    void FrameBuffer::Bind() {
        //glBindFramebuffer(GL_FRAMEBUFFER, BufferID);
    }

    void FrameBuffer::Unbind() {
        //glBindFramebuffer(GL_FRAMEBUFFER, 0);
    }

    void FrameBuffer::AddAttachment(int idx, int internalFormat, int format, int width, int height) {
        // TODO: Kick Rocks Until We Update OpenGL
        unsigned int rt;
        glGenTextures(1, &rt);
        glBindTexture(GL_TEXTURE_2D, rt);
        glTexImage2D(GL_TEXTURE_2D, 0, internalFormat, width, height, 0, format, GL_FLOAT, NULL);
        glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
        glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
            //glFramebufferTexture2D(GL_FRAMEBUFFER, GL_COLOR_ATTACHMENT0 + idx, GL_TEXTURE_2D, rt, 0);

            Attachments.push_back(rt);
    }

}
