


#pragma once

#include <vector>
#include "glad/glad.h"
#include <J3ML/J3ML.h>
#include <iostream>

namespace LearnOpenGL
{
    class FrameBuffer
    {
    public: // data
        GLuint BufferID;
        u32 DepthAttachment;
        std::vector<u32> Attachments;
    public: // methods
        FrameBuffer();
        ~FrameBuffer();
        void Create(int width, int height, bool enableDepth);
        void Bind();
        void Unbind();
        void AddAttachment(int idx, int internalFormat, int format, int width, int height);
    };
}